import { BackendProxy } from "@kie-tools-core/backend/dist/api";
import { WorkspaceEdit, ResourceContentRequest, ResourceContentService, ResourceListRequest, WorkspaceChannelApi } from "@kie-tools-core/workspace/dist/api";
import { EditorContent, KogitoEditorChannelApi, StateControlCommand } from "@kie-tools-core/editor/dist/api";
import { Tutorial, UserInteraction } from "@kie-tools-core/guided-tour/dist/api";
import { VsCodeKieEditorController } from "./VsCodeKieEditorController";
import { Notification, NotificationsChannelApi } from "@kie-tools-core/notifications/dist/api";
import { VsCodeI18n } from "./i18n";
import { I18n } from "@kie-tools-core/i18n/dist/core";
import { JavaCodeCompletionAccessor, JavaCodeCompletionApi, JavaCodeCompletionChannelApi, JavaCodeCompletionClass } from "@kie-tools-core/vscode-java-code-completion/dist/api";
export declare class DefaultVsCodeKieEditorChannelApiImpl implements KogitoEditorChannelApi, JavaCodeCompletionChannelApi {
    private readonly editor;
    private readonly resourceContentService;
    private readonly workspaceApi;
    private readonly backendProxy;
    private readonly notificationsApi;
    private readonly javaCodeCompletionApi;
    private readonly viewType;
    private readonly i18n;
    constructor(editor: VsCodeKieEditorController, resourceContentService: ResourceContentService, workspaceApi: WorkspaceChannelApi, backendProxy: BackendProxy, notificationsApi: NotificationsChannelApi, javaCodeCompletionApi: JavaCodeCompletionApi, viewType: string, i18n: I18n<VsCodeI18n>);
    kogitoWorkspace_newEdit(workspaceEdit: WorkspaceEdit): Promise<void>;
    kogitoWorkspace_openFile(path: string): void;
    kogitoEditor_contentRequest(): Promise<{
        content: string;
        path: string;
    }>;
    kogitoEditor_setContentError(editorContent: EditorContent): void;
    kogitoEditor_ready(): void;
    kogitoEditor_theme(): {
        defaultValue: import("@kie-tools-core/editor/dist/api").EditorTheme;
    };
    kogitoEditor_stateControlCommandUpdate(command: StateControlCommand): void;
    kogitoGuidedTour_guidedTourRegisterTutorial(tutorial: Tutorial): void;
    kogitoGuidedTour_guidedTourUserInteraction(userInteraction: UserInteraction): void;
    kogitoWorkspace_resourceContentRequest(request: ResourceContentRequest): Promise<import("@kie-tools-core/workspace/dist/api").ResourceContent | undefined>;
    kogitoWorkspace_resourceListRequest(request: ResourceListRequest): Promise<import("@kie-tools-core/workspace/dist/api").ResourcesList>;
    kogitoI18n_getLocale(): Promise<string>;
    kogitoNotifications_createNotification(notification: Notification): void;
    kogitoNotifications_setNotifications(path: string, notifications: Notification[]): void;
    kogitoNotifications_removeNotifications(path: string): void;
    kogitoJavaCodeCompletion__getAccessors(fqcn: string, query: string): Promise<JavaCodeCompletionAccessor[]>;
    kogitoJavaCodeCompletion__getClasses(query: string): Promise<JavaCodeCompletionClass[]>;
    kogitoJavaCodeCompletion__isLanguageServerAvailable(): Promise<boolean>;
}
//# sourceMappingURL=DefaultVsCodeKieEditorChannelApiImpl.d.ts.map