"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.VsCodeNodeResourceContentServiceImpl = void 0;
var api_1 = require("@kie-tools-core/workspace/dist/api");
var minimatch = require("minimatch");
var vscode = require("vscode");
var VsCodeNodeResourceContentServiceImpl = (function () {
    function VsCodeNodeResourceContentServiceImpl(rootFolder) {
        this.rootFolder = rootFolder;
    }
    VsCodeNodeResourceContentServiceImpl.prototype.list = function (pattern, opts) {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                return [2, new Promise(function (resolve, reject) {
                        vscode.workspace.fs.readDirectory(vscode.Uri.parse(_this.rootFolder)).then(function (files) {
                            var paths = files
                                .filter(function (_a) {
                                var _b = __read(_a, 2), name = _b[0], depth = _b[1];
                                var fileName;
                                if ((opts === null || opts === void 0 ? void 0 : opts.type) === api_1.SearchType.TRAVERSAL) {
                                    fileName = _this.rootFolder + name;
                                }
                                else {
                                    fileName = name;
                                }
                                return depth === 1 && minimatch(name, pattern);
                            })
                                .map(function (_a) {
                                var _b = __read(_a, 1), name = _b[0];
                                return _this.rootFolder + name;
                            });
                            resolve(new api_1.ResourcesList(pattern, paths));
                        }, function (_err) {
                            resolve(new api_1.ResourcesList(pattern, []));
                        });
                    })];
            });
        });
    };
    VsCodeNodeResourceContentServiceImpl.prototype.get = function (path, opts) {
        return __awaiter(this, void 0, void 0, function () {
            var assetPath;
            return __generator(this, function (_a) {
                assetPath = path;
                if (!assetPath.startsWith(this.rootFolder)) {
                    assetPath = this.rootFolder + path;
                }
                if ((opts === null || opts === void 0 ? void 0 : opts.type) === api_1.ContentType.BINARY) {
                    return [2, new Promise(function (resolve, reject) {
                            vscode.workspace.fs.readFile(vscode.Uri.parse(assetPath)).then(function (data) { return resolve(new api_1.ResourceContent(path, Buffer.from(data).toString("base64"), api_1.ContentType.BINARY)); }, function (_err) { return resolve(new api_1.ResourceContent(path, undefined, api_1.ContentType.BINARY)); });
                        })];
                }
                return [2, new Promise(function (resolve, reject) {
                        vscode.workspace.fs.readFile(vscode.Uri.parse(assetPath)).then(function (data) { return resolve(new api_1.ResourceContent(path, Buffer.from(data).toString(), api_1.ContentType.TEXT)); }, function (_err) { return resolve(new api_1.ResourceContent(path, undefined)); });
                    })];
            });
        });
    };
    return VsCodeNodeResourceContentServiceImpl;
}());
exports.VsCodeNodeResourceContentServiceImpl = VsCodeNodeResourceContentServiceImpl;
//# sourceMappingURL=VsCodeNodeResourceContentServiceImpl.js.map